﻿# CoffeeScript
class @UsersClass
  options =
    allowEdit: false
    editUrl: null
    deleteUrl: null

  $SpeedFiltr = null
  $trSelected = null
  table = null
  $tbl = null
  $fmFiltr = null

  constructor: (opt) ->
    options = opt
    initTable()
    return

  # udalost pred odeslanim filtru ajaxem na server
  getFiltrData = (d) ->
    if $SpeedFiltr is null
      $SpeedFiltr = $("#tbl-data_filter input")
    data = $fmFiltr.serializeObject()
    data["Start"] = d.start
    data["Length"] = d.length
    data["SpeedFiltr"] = $SpeedFiltr.val()
    if d.order && d.order.length > 0
      ord = d.columns[d.order[0].column].data
      data["Order"] = ord
      data["OrderDir"] = d.order[0].dir
    return data

  cellDrawActive = (nTd, sData, oData, i) ->
    stav = if oData.Active then "ok text-success" else "remove text-muted"
    html = "<span class='glyphicon glyphicon-#{stav}'></span>"
    $(nTd).addClass("text-center").html(html)
    $(nTd).closest("tr").data("id", oData.ID)

  cellDrawState = (nTd, sData, oData, i) ->
    stav = if sData then "ok text-success" else "remove text-muted"
    html = "<span class='glyphicon glyphicon-#{stav}'></span>"
    $(nTd).addClass("text-center").html(html)    

  tableClick = (e) ->
    $target = $(e.target)
    $tr = $target.closest("tr")
    if options.allowEdit
        window.location.href = options.editUrl + "/" + $tr.data("id")
    return

  initTable = () ->
    $tbl = $("#tbl-data")
    $fmFiltr = $("#fmFiltr")

    $el = $fmFiltr.find("select[name=LogLevel]")
    $el.select2
      allowClear: true
      placeholder: $el.data("placeholder")

    $fmFiltr.find("select").on "change", (e) -> table.ajax.reload()

    cols = [
      { mData: "Active", sWidth: 50, fnCreatedCell: cellDrawActive }
      { mData: "IsAdmin", sWidth: 50, fnCreatedCell: cellDrawState, bSortable: false }
      { mData: "IsAllowEdit", sWidth: 50, fnCreatedCell: cellDrawState, bSortable: false }
      { mData: "Fullname" }
      { mData: "UserName" }
      { mData: "Email" }
    ]

    aoColumnDefs = []
    for cl, i in cols
      cl.aTargets = i
      aoColumnDefs.push cl

    opt =
      responsive: true
      aoColumnDefs: aoColumnDefs
      searching: true
      serverSide: true
      processing: true
      ajax:
        url: $fmFiltr.attr("action")
        type: "POST"
        data: getFiltrData

    $th = $tbl.find("thead tr").empty()
    for cl in aoColumnDefs
      cssClass = if cl.bSortable isnt false then "sorting" else ""
      $th.append $("<th aria-controls='tbl-data-bike' class='#{cssClass}'/>").text(txt[cl.mData])

    table = $tbl.DataTable helper.tableDefOpt(opt)
    $tbl.find("tbody").on "click", "td", tableClick
    return