# CoffeeScript
class @LogsClass
  options =
    allowEdit: false
    editUrl: null
    printUrl: null
    deleteFullUrl: null
    deleteUrl: null
    syncUrl: null

  $SpeedFiltr = null
  $trSelected = null
  table = null
  $tbl = null
  $fmFiltr = null
  levelTexts = ['', 'DEBUG', 'ERROR', 'FATAL', 'INFO', 'WARN' ]
  levelColors = ['', 'text-muted', 'text-danger', 'text-danger', 'text-info', 'text-warning' ]

  constructor: (opt) ->
    options = opt
    initTable()
    $("#btFiltr").click (e) ->
      e.preventDefault()
      $("#dlg-filtr").modal "show"
      return

    return

  cellDrawLogLevel = (nTd, sData, oData, i) ->
    text = ""
    text = txt[levelTexts[oData.LogLevel]] if oData.LogLevel > 0
    $(nTd).addClass(levelColors[oData.LogLevel]).html(text)

  cellDrawDetail = (nTd, sData, oData, i) ->
    $html = $("<a/>")
    $html.addClass("fa fa-search").attr("href", "LogsDetail/" + sData).text(" ")
    $(nTd).addClass("text-center").empty().append($html)
    return

  # udalost pred odeslanim filtru ajaxem na server
  getFiltrData = (d) ->
    if $SpeedFiltr is null
      $SpeedFiltr = $("#tbl-data_filter input")
    data = $fmFiltr.serializeObject()
    data["Start"] = d.start
    data["Length"] = d.length
    data["SpeedFiltr"] = $SpeedFiltr.val()
    if d.order && d.order.length > 0
      data["Order"] = "DateCreate"
      data["OrderDir"] = "desc"
    return data

  initTable = () ->
    $tbl = $("#tbl-data")
    $fmFiltr = $("#fmFiltr")

    $el = $fmFiltr.find("select[name=LogLevel]")
    $el.select2
      allowClear: true
      placeholder: $el.data("placeholder")

    $fmFiltr.find("select").on "change", (e) -> table.ajax.reload()

    cols = [
      { mData: "ID", sWidth: 30, fnCreatedCell: cellDrawDetail, bSortable: false }
      { mData: "LogLevel", sWidth: 50, fnCreatedCell: cellDrawLogLevel, bSortable: false }
      { mData: "DateCreate", bSortable: false }
      { mData: "Event", bSortable: false }
      { mData: "Msg", bSortable: false }
      { mData: "FullUserName", bSortable: false }
    ]

    aoColumnDefs = []
    for cl, i in cols
      cl.aTargets = i
      aoColumnDefs.push cl

    opt =
      responsive: true
      aoColumnDefs: aoColumnDefs
      searching: true
      serverSide: true
      processing: true
      ajax:
        url: $fmFiltr.attr("action")
        type: "POST"
        data: getFiltrData

    $th = $tbl.find("thead tr").empty()
    for cl in aoColumnDefs
      cssClass = if cl.bSortable isnt false then "sorting" else ""
      $th.append $("<th aria-controls='tbl-data-bike' class='#{cssClass}'/>").text(txt[cl.mData])

    table = $tbl.DataTable helper.tableDefOpt(opt)

    return