﻿# CoffeeScript
class RestoreServer

    $dlgDetail: null
    $dlgObnova = null	
    table = null
    worked = 0
    stopRequest = false

    ###
    Načte detail předmětu z centrálního serveru
    ###
    loadDetail: (id) =>
        __this = this
        url = this.$dlgDetail.data "loadurl"
        
        request = $.post(url + "/" + id)
        request.fail App.showAjaxFail
        request.done (data) ->				
            App.progressHide()
            if data.error				
                App.error data.msg
            else	
                $("#tabsDetail").tabs("destroy")				
                $dlg = $("#dlgDetail")
                keys = ["Name", "RegNumber", "CodeType", "CodeMicro", "Group", "Desc"]
                for k in keys
                    $dlg.find("[name=#{k}]").val data[k]
                __this.createTabPhotos id, data.Photos
                $("#tabsDetail").tabs()				
                $dlg.dialog "option", "title", data.Name
                $dlg.dialog "open"
            return		
        return
        
    ###
    Vygeneruje záložky s fotkami předmětu
    ###
    createTabPhotos: (id, photos) =>
        urlPhoto = $("#dlgDetail").data("photourl") + "/" + id + "?phIndex="
        $tabsDetail = $("#tabsDetail")
        $tabsDetail.find("li:not(#li-1)").remove()
        $tabsDetail.find("img").unbind("load")
        $tabsDetail.find("div.ph").remove()
        $ul = $tabsDetail.find("ul")
        for p in photos
            elId = "tb-ph-" + p.Index
            $a = $("<a/>").text("Foto " + p.Index).attr("href", "#" + elId)
            $li = $("<li/>").append($a)
            $ul.append($li)
            $div = $("<div class='ph'/>").attr("id", elId)
            $div.append($("<img style='display:none;' />").attr("src", urlPhoto + p.Index))
            $tabsDetail.append($div)
            
        # události kontrolující zda je obrázek korektně stažený
        $images = $tabsDetail.find("img")
        $images.load ->	$(this).show()
        $images.error -> $(this).parent().append("chyba")
            
        return


    ###
    Inicializuje dialog pro zobrazení detailu kola ze serveru
    ###
    showDetail: (sender) =>
        $this = $(sender.target).closest("tr")		
        if this.$dlgDetail is null
            this.$dlgDetail = $("#dlgDetail").dialog
                autoOpen: false
                modal: true
                width: 900
                height: 650
                buttons: [
                    {
                        text: txt.btn_cancel
                        click: -> $(@).dialog "close"
                    }
                ]
            $("#tabsDetail").tabs()
        
        this.$dlgDetail.find(".content").empty()
        App.progressShow()
        this.loadDetail $this.data("id")
        
        return
        
    ###
    Událost pro obnovení dat které nejsou na lokálním serveru
    ###	
    onRestoreMissing: ->
        url = $("#btRestoreMissing").data "url"
        App.progressShow()
        request = $.post(url)
        request.fail App.showAjaxFail
        request.done (data) ->				
            if data.error
                App.progressHide()
                App.error data.msg
            else
                #window.location.reload()
                table.ajax.reload()
            return
        return
        
    ###
    Událost po načtení dat ze serveru do hlavní tabulky
    ###
    onPostAjaxCallback: (e, settings, json, xhr) =>
        App.progressHide()
        if json.error
            App.error(json.msg)
        else
            if json.missing is 0
                $( "#btRestoreMissing" ).button( "option", "disabled", true );
        return
        
    @stopRestoreData = () ->		
        stopRequest = true
        App.progressMsg txt.RestoreMissingDataProcess		
        return
        
    ###
    Spustí obnovu chybějících dat ze serveru
    ###
    startRestoreData = (during) =>
        __this = @
        $("#progressBar").on "click", "button.stop", (e) ->
            e.preventDefault()
            __this.stopRestoreData()
            return false
        stopRequest = false
        stopButton = "</div><button class='stop'>Zastavit</button>"
        conf = $dlgObnova.data()
        if !during
            App.progressShow("<div>Obnova dat byla zahájena...</div>" + stopButton)		
        postData =
            idOwner: $("#selOwner").data "id"
        request = $.post(conf.url, postData)
        request.fail App.showAjaxFail
        request.done (data) ->		
            $("#progressBar").off "click", "button.stop"	
            if data.error
                App.progressHide()
                App.alert data.msg
            else		
                if data.finnish or stopRequest
                    App.progressHide()
                    $("#dlgObnova").dialog "close"
                    table.ajax.reload()
                    App.alert("Obnova dat byla dokončena")
                else
                    worked = worked + data.worked
                    msg = "<div>Zpracováno " + worked + " položek, zbývá " + data.missing + stopButton
                    App.progressMsg msg
                    startRestoreData(true)
            return		
        return
        
    ###
    Zobrazí dialog pro obnovení dat z centrály
    ###
    showDlgResotoreMissing = () ->
        if $dlgObnova is null
            $dlgObnova = $("#dlgObnova");
            $dlgObnova.dialog
                autoOpen: false
                modal: true
                width: 800
                buttons: [
                    {
                        id: "btStartRestore"
                        text: "Spustit obnovu"
                        click: -> startRestoreData(false)
                    }
                    {
                        text: txt.btn_cancel
                        click: -> $(@).dialog "close"
                    }
                ]
            $("#btStartRestore").prop("disabled",true)
            $("#owner").autocomplete
                minLength: 2
                source: $("#owner").data("url")
                select: (event, ui) ->					
                    $("#selOwner").data "id", ui.item.id
                    getOwnerInfo()					
                    return
                
        $dlgObnova.dialog "open"
        return	
        
    ###
    Zobrazí detailní informace o vybraném vlastníkovi
    ###
    getOwnerInfo = () ->
        id = $("#selOwner").data "id"
        $("#selOwner").text ""
        App.progressShow()
        $.ajax
            type: "post"
            url: $("#owner").data("urlinfo")
            data: "id=" + id + "&find=" + find
            success: (data) ->
                App.progressHide()
                if data.error
                    App.alert data.msg
                else		
                    d = data.data	
                    txt = "Obnovená data budou přiřazena:\n" + d.Surname + " " + d.Name + "\n" + d.Address						
                    $("#selOwner").text txt
                    $("#btStartRestore").prop("disabled",false)
                    
                return
            error: App.showAjaxFail
        return
        
    @onRefreshData = (e) ->
        window.location.href = "?refresh=true"
        return
        
    ###
    Konstruktor
    ###
    constructor: ->
    
        $("#btRestoreMissing").button().click showDlgResotoreMissing
        #$("#btOwnerExists").button().click getOwnerInfo
        
        $("#btRefresh").button().click RestoreServer.onRefreshData
        
        # vygeneruje checkbox pro oznaceni v tabulce z koly
        checkboxInTable = (id, regNumber) ->
            html = "<input type='checkbox' class='marked' value='#{regNumber}' autocomplete='off' />"
            return html
            


        columns = [				
                { mData: "RegNumber" }
                { mData: "DateReg" }
                { mData: "Name" }
                { mData: "State" }
            ]
            
        
        columnDefs = [
                {
                    aTargets: [0]
                    sClass: "RegNumber"
                    fnCreatedCell: (nTd, sData, oData, i) ->
                        $nTd = $(nTd)
                        $nTd.html(sData)
                        $nTd.closest("tr").data "id", oData.RegNumber
                        return
                        
                }
            ]
            
        opt =			
            bAutoWidth		: false
            bFilter			: false
            bPaginate		: false
            sDom			: "lptip"
            bInfo			: true
            bProcessing		: true
            serverSide		: true
            bStateSave      : true					# ukládat nastavení tabulky
            sPaginationType : "full_numbers"		# zobrazit navigaci pomocí čísel stránek
            oLanguage       : txt.dataTable			# textové překlady pro tabulku
            bJQueryUI       : false					# nepoužívat JQueryUI téma
            aoColumns		: columns
            aoColumnDefs	: columnDefs			
            ajax: {
                url: $("#tblData").data("loadurl")
                type: "POST"
                data: (d) ->
                    ord_0 = d.order[0]		
                    data =
                        Sort: d.columns[ord_0.column].data
                        Dir: ord_0.dir
                        Start: 0
                        PageSize: 100
                    start = false
                    return data				
            }
        
        App.progressShow()
        # inicializace datove tabulky
        table = $("#tblData").on("xhr.dt", this.onPostAjaxCallback).DataTable opt
        $("#tblData tbody").on "click", "tr", this.showDetail
        
        return

$ ->
    window.rest = new RestoreServer
    return