﻿// Generated by IcedCoffeeScript 108.0.11
(function() {
  var RestoreServer,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  RestoreServer = (function() {
    var $dlgObnova, getOwnerInfo, showDlgResotoreMissing, startRestoreData, stopRequest, table, worked;

    RestoreServer.prototype.$dlgDetail = null;

    $dlgObnova = null;

    table = null;

    worked = 0;

    stopRequest = false;


    /*
    Načte detail předmětu z centrálního serveru
     */

    RestoreServer.prototype.loadDetail = function(id) {
      var request, url, __this;
      __this = this;
      url = this.$dlgDetail.data("loadurl");
      request = $.post(url + "/" + id);
      request.fail(App.showAjaxFail);
      request.done(function(data) {
        var $dlg, k, keys, _i, _len;
        App.progressHide();
        if (data.error) {
          App.error(data.msg);
        } else {
          $("#tabsDetail").tabs("destroy");
          $dlg = $("#dlgDetail");
          keys = ["Name", "RegNumber", "CodeType", "CodeMicro", "Group", "Desc"];
          for (_i = 0, _len = keys.length; _i < _len; _i++) {
            k = keys[_i];
            $dlg.find("[name=" + k + "]").val(data[k]);
          }
          __this.createTabPhotos(id, data.Photos);
          $("#tabsDetail").tabs();
          $dlg.dialog("option", "title", data.Name);
          $dlg.dialog("open");
        }
      });
    };


    /*
    Vygeneruje záložky s fotkami předmětu
     */

    RestoreServer.prototype.createTabPhotos = function(id, photos) {
      var $a, $div, $images, $li, $tabsDetail, $ul, elId, p, urlPhoto, _i, _len;
      urlPhoto = $("#dlgDetail").data("photourl") + "/" + id + "?phIndex=";
      $tabsDetail = $("#tabsDetail");
      $tabsDetail.find("li:not(#li-1)").remove();
      $tabsDetail.find("img").unbind("load");
      $tabsDetail.find("div.ph").remove();
      $ul = $tabsDetail.find("ul");
      for (_i = 0, _len = photos.length; _i < _len; _i++) {
        p = photos[_i];
        elId = "tb-ph-" + p.Index;
        $a = $("<a/>").text("Foto " + p.Index).attr("href", "#" + elId);
        $li = $("<li/>").append($a);
        $ul.append($li);
        $div = $("<div class='ph'/>").attr("id", elId);
        $div.append($("<img style='display:none;' />").attr("src", urlPhoto + p.Index));
        $tabsDetail.append($div);
      }
      $images = $tabsDetail.find("img");
      $images.load(function() {
        return $(this).show();
      });
      $images.error(function() {
        return $(this).parent().append("chyba");
      });
    };


    /*
    Inicializuje dialog pro zobrazení detailu kola ze serveru
     */

    RestoreServer.prototype.showDetail = function(sender) {
      var $this;
      $this = $(sender.target).closest("tr");
      if (this.$dlgDetail === null) {
        this.$dlgDetail = $("#dlgDetail").dialog({
          autoOpen: false,
          modal: true,
          width: 900,
          height: 650,
          buttons: [
            {
              text: txt.btn_cancel,
              click: function() {
                return $(this).dialog("close");
              }
            }
          ]
        });
        $("#tabsDetail").tabs();
      }
      this.$dlgDetail.find(".content").empty();
      App.progressShow();
      this.loadDetail($this.data("id"));
    };


    /*
    Událost pro obnovení dat které nejsou na lokálním serveru
     */

    RestoreServer.prototype.onRestoreMissing = function() {
      var request, url;
      url = $("#btRestoreMissing").data("url");
      App.progressShow();
      request = $.post(url);
      request.fail(App.showAjaxFail);
      request.done(function(data) {
        if (data.error) {
          App.progressHide();
          App.error(data.msg);
        } else {
          table.ajax.reload();
        }
      });
    };


    /*
    Událost po načtení dat ze serveru do hlavní tabulky
     */

    RestoreServer.prototype.onPostAjaxCallback = function(e, settings, json, xhr) {
      App.progressHide();
      if (json.error) {
        App.error(json.msg);
      } else {
        if (json.missing === 0) {
          $("#btRestoreMissing").button("option", "disabled", true);
        }
      }
    };

    RestoreServer.stopRestoreData = function() {
      stopRequest = true;
      App.progressMsg(txt.RestoreMissingDataProcess);
    };


    /*
    Spustí obnovu chybějících dat ze serveru
     */

    startRestoreData = function(during) {
      var conf, postData, request, stopButton, __this;
      __this = RestoreServer;
      $("#progressBar").on("click", "button.stop", function(e) {
        e.preventDefault();
        __this.stopRestoreData();
        return false;
      });
      stopRequest = false;
      stopButton = "</div><button class='stop'>Zastavit</button>";
      conf = $dlgObnova.data();
      if (!during) {
        App.progressShow("<div>Obnova dat byla zahájena...</div>" + stopButton);
      }
      postData = {
        idOwner: $("#selOwner").data("id")
      };
      request = $.post(conf.url, postData);
      request.fail(App.showAjaxFail);
      request.done(function(data) {
        var msg;
        $("#progressBar").off("click", "button.stop");
        if (data.error) {
          App.progressHide();
          App.alert(data.msg);
        } else {
          if (data.finnish || stopRequest) {
            App.progressHide();
            $("#dlgObnova").dialog("close");
            table.ajax.reload();
            App.alert("Obnova dat byla dokončena");
          } else {
            worked = worked + data.worked;
            msg = "<div>Zpracováno " + worked + " položek, zbývá " + data.missing + stopButton;
            App.progressMsg(msg);
            startRestoreData(true);
          }
        }
      });
    };


    /*
    Zobrazí dialog pro obnovení dat z centrály
     */

    showDlgResotoreMissing = function() {
      if ($dlgObnova === null) {
        $dlgObnova = $("#dlgObnova");
        $dlgObnova.dialog({
          autoOpen: false,
          modal: true,
          width: 800,
          buttons: [
            {
              id: "btStartRestore",
              text: "Spustit obnovu",
              click: function() {
                return startRestoreData(false);
              }
            }, {
              text: txt.btn_cancel,
              click: function() {
                return $(this).dialog("close");
              }
            }
          ]
        });
        $("#btStartRestore").prop("disabled", true);
        $("#owner").autocomplete({
          minLength: 2,
          source: $("#owner").data("url"),
          select: function(event, ui) {
            $("#selOwner").data("id", ui.item.id);
            getOwnerInfo();
          }
        });
      }
      $dlgObnova.dialog("open");
    };


    /*
    Zobrazí detailní informace o vybraném vlastníkovi
     */

    getOwnerInfo = function() {
      var id;
      id = $("#selOwner").data("id");
      $("#selOwner").text("");
      App.progressShow();
      $.ajax({
        type: "post",
        url: $("#owner").data("urlinfo"),
        data: "id=" + id + "&find=" + find,
        success: function(data) {
          var d, txt;
          App.progressHide();
          if (data.error) {
            App.alert(data.msg);
          } else {
            d = data.data;
            txt = "Obnovená data budou přiřazena:\n" + d.Surname + " " + d.Name + "\n" + d.Address;
            $("#selOwner").text(txt);
            $("#btStartRestore").prop("disabled", false);
          }
        },
        error: App.showAjaxFail
      });
    };

    RestoreServer.onRefreshData = function(e) {
      window.location.href = "?refresh=true";
    };


    /*
    Konstruktor
     */

    function RestoreServer() {
      this.onPostAjaxCallback = __bind(this.onPostAjaxCallback, this);
      this.showDetail = __bind(this.showDetail, this);
      this.createTabPhotos = __bind(this.createTabPhotos, this);
      this.loadDetail = __bind(this.loadDetail, this);
      var checkboxInTable, columnDefs, columns, opt;
      $("#btRestoreMissing").button().click(showDlgResotoreMissing);
      $("#btRefresh").button().click(RestoreServer.onRefreshData);
      checkboxInTable = function(id, regNumber) {
        var html;
        html = "<input type='checkbox' class='marked' value='" + regNumber + "' autocomplete='off' />";
        return html;
      };
      columns = [
        {
          mData: "RegNumber"
        }, {
          mData: "DateReg"
        }, {
          mData: "Name"
        }, {
          mData: "State"
        }
      ];
      columnDefs = [
        {
          aTargets: [0],
          sClass: "RegNumber",
          fnCreatedCell: function(nTd, sData, oData, i) {
            var $nTd;
            $nTd = $(nTd);
            $nTd.html(sData);
            $nTd.closest("tr").data("id", oData.RegNumber);
          }
        }
      ];
      opt = {
        bAutoWidth: false,
        bFilter: false,
        bPaginate: false,
        sDom: "lptip",
        bInfo: true,
        bProcessing: true,
        serverSide: true,
        bStateSave: true,
        sPaginationType: "full_numbers",
        oLanguage: txt.dataTable,
        bJQueryUI: false,
        aoColumns: columns,
        aoColumnDefs: columnDefs,
        ajax: {
          url: $("#tblData").data("loadurl"),
          type: "POST",
          data: function(d) {
            var data, ord_0, start;
            ord_0 = d.order[0];
            data = {
              Sort: d.columns[ord_0.column].data,
              Dir: ord_0.dir,
              Start: 0,
              PageSize: 100
            };
            start = false;
            return data;
          }
        }
      };
      App.progressShow();
      table = $("#tblData").on("xhr.dt", this.onPostAjaxCallback).DataTable(opt);
      $("#tblData tbody").on("click", "tr", this.showDetail);
      return;
    }

    return RestoreServer;

  })();

  $(function() {
    window.rest = new RestoreServer;
  });

}).call(this);
