﻿# CoffeeScript
class @AdminClass
  options =
    isAdmin: false
    urlSaveLogo: null

  $fmEdit = null
  $fmSmtp = null
  $validEdit = null

  constructor: (opt) ->
    anchor = document.location.hash
    options = opt
    initMainTab()
    initSmtpTab()
    initLogoTab()
    $('#tab-main .nav-tabs a[href="' + anchor + '"]').tab('show');
    return

  # inicializace hlavniho formulare
  initMainTab = () ->
    $fmEdit = $("#fmEdit")

    editRules =
      rules:
        CentralCode:
          required: true
          regex: /^[a-z]+$/
        BakupInterval:
          regex: /^[0-9]{1,3}$/
      messages:
        CentralCode:
          regex: App.getResource("err_valid_little_chars")

    $validEdit = $fmEdit.validate(editRules)

    $fmEdit.find("#btSave").button().click ->
      if $fmEdit.valid()
        App.progressShow()
        $.post($fmEdit.attr("action"), $fmEdit.serialize()).fail(App.showAjaxFail).done(afterSaveMain)
    return

  # udalost po ulozeni/odeslani hlavniho formulare
  afterSaveMain = (data) ->
    App.progressHide()
    if data.error
      App.error data.msg
    else
      App.alert(data.msg)
    return

  # inicializace formuláře pro test SMTP
  initSmtpTab = () ->
    $fmSmtp = $("#smtp").find("form")
    $fmSmtp.validate()
    $("#btSendMailToTest").button().click (evn) ->
      evn.preventDefault()
      url = $fmSmtp.prop "action"
      if $fmSmtp.valid()
        App.progressShow()
        $.post(url, $fmSmtp.serialize()).done(afterTestSmtp).fail(App.showAjaxFail)
      return
    return

  # událost po odeslání testovacího mailu
  afterTestSmtp = (data) ->
    App.progressHide()
    if data.error
      App.error data.msg
    else
      App.alert(data.msg)
    return

  # inicializace formulare pro zmenu loga aplikace
  initLogoTab = () ->
    $("#btSaveLogo").button().click (evn) ->
      evn.preventDefault()
      sendLogo()
      return

    return

  # ulozeni/odeslani zmeneho loga
  sendLogo = () ->
    fileData = $("#MainLogo").prop("files")[0];
    if fileData
      frmData = new FormData()
      frmData.append("MainLogo", fileData)
      opt =
        url: options.urlSaveLogo
        dataType: "json"
        cache: false
        contentType: false
        processData: false
        data: frmData
        type: "post"
        success: afterSendLog
        fail: App.showAjaxFail
      $.ajax opt
    else
      App.alert txt.err_applogo_not_selected
    return

  # udalost po ulozeni/odeslani loga
  afterSendLog = (data) ->
    if data.error
      App.alert data.msg
    else
      $("#img-logo").attr("src", $("#img-logo").attr("src") + "1")
    return