class @EditBikeClass
  options =
    allowEdit: false
    fmEdit: null
    $dlgAddProp: null
    urlIndex: null
    urlOwners: null
    urlOwnerDetail: null
    urlVendorDlgHtml: null
    urlImgUpload: null
    imgAjaxUploader: null
    urlImage: null
    urlImgRemove: null
    guidEditor: null
    srcEmptyImg: null

  $fmEdit = null
  $isFirmVendor = null
  $isFirmOwner = null
  $fmAddProp = null
  $selectedPropInput = null
  $typeProps = null
  $findOwnerBike = null
  $findVendor = null
  $dlgAddVendor = null
  $fmVendor = null
  $tabsFoto = null
  closeAfterSave = true

  constructor: (opt) ->
    options = opt
    $fmEdit = opt.fmEdit
    $dlgAddVendor = $("#dlg-add-vendor")
    $fmVendor = $dlgAddVendor.find("form")    
    $fmEdit.validate
      ignore: []
      rules:
        "Width":
            regex: /^\d{0,8}([,\.]\d{0,2})?$/
        "Price":
            regex: /^\d{0,8}([,\.]\d{0,2})?$/

    $fmEdit.find("#btn-save, #btn-save-noclose").click btnSaveClick
    $fmEdit.find("#btn-cancel").click -> window.location.href = options.urlIndex
    $isFirmOwner = $("#OwnerBike_IsFirm")
    $isFirmOwner.change isFirmOwnerChange

    initPropDialog()

    $("#props").find('a[data-toggle="tab"]').on 'shown.bs.tab', (e) -> showTabProp($(e.target))
    $fmEdit.find("#IDState").change(changeState).trigger("change")
    $('#DateEvent').datetimepicker({
      collapse: false,
      sideBySide: true,
      format: "DD.MM.YYYY HH:mm",
      locale: configJS.lang,
      allowInputToggle: true
    })    

    initPhotos()
    initFindOwnerBike("Find-OwnerBike")
    initOldOwnerBike("Old-OwnerBike")
    #clickOnFirm()
    initBikeTypeTabs()
    initFindVendor("Vendor")
    initTabMain("tab-main")
    showTabProp($("#props li.active a"))

    $fmEdit.find("select").select2()
    if !options.allowEdit
      $fmEdit.find("input:text, textarea").prop("readonly", true)
      $fmEdit.find("select").select2("readonly", true)

    $(document).on 'click', '[data-toggle="lightbox"]', (event) ->
        event.preventDefault();
        $(@).ekkoLightbox();
        return

    isFirmOwnerChange(null)
    $(document).keydown shortcutCase

    return

  # spuštění akce na pověšené na daném elementi id - používá se pro zkratkové klávesy
  shortcutAction = (e, id) ->
    e.preventDefault()
    $a = $(id).find("a")
    $a.trigger "click"
    return

  # řešení pro použití zkratkových kláves
  shortcutCase = (e) ->
    if e.ctrlKey
      switch e.keyCode
        # D - Předmět
        when 68 then shortcutAction(e, "#RegSubjectTab")
        # M - Majitel
        when 77 then shortcutAction(e, "#OwnerTab")
        # I - Informace
        when 73 then shortcutAction(e, "#InfoExtendTab")
        # F - Fotogalerie
        when 70 then shortcutAction(e, "#PhotosTab")  
    return

  # inicializace komponenty s hlavnimi zalozkami
  initTabMain = (elementId) ->
    firstTab = "RegSubject"
    hash = window.location.hash.substr(1);
    hash = firstTab if (hash is "")
    $("#" + elementId).find('a[data-toggle="tab"]').on 'shown.bs.tab', (e) ->
      href = $(e.target).data("href")
      if href is firstTab
        window.location.hash = ''
      else
        window.location.href = $(e.target).prop("href")
    $("#" + hash + "Tab a").tab("show")
    return

  # inicializace záložky s fotografiemi
  initPhotos = () ->
    $tabsFoto = $("#Photos")
    return if !options.allowEdit
    $tabsFoto.find("input:file").change changePhoto
    $tabsFoto.find("button[data-del-photo]").click clickDeltePhoto
    return

  # inicializace autocomplete pro hledání prodejce
  initFindVendor = (elementId) ->
    return if !options.allowEdit    
    $findVendor = $("#" + elementId)
    value = $findVendor.val()    
    $findVendor.select2
      minimumInputLength: 2
      width: "off"
      ajax:
        url: options.urlOwners
        dataType: "json"
        type: "GET"
        quietMillis: 250
        data: (term, page) ->
          return { term: term }
        results: (data, page) ->
          return { results: data.data }
      formatResult: (option) ->
        return "<div><strong>#{option.label}</strong>, #{option.address}</div>"
      formatSelection: (option) ->
        $fmEdit.find("#IDVendor").val option.id
        return option.label

    $findVendor.select2 "data",
        id: $fmEdit.find("#IDVendor").val()
        label: value


    $findVendor.closest(".input-group").find(".find-remove-vendor").click (e) ->
      e.preventDefault()
      $fmEdit.find("#IDVendor").val ""
      $findVendor.select2 "val", ""
      return

    $findVendor.closest(".input-group").find(".add-vendor").click clickOnAddVendor
    return

  # kliknutí na tlačítko pro zobrazení dialogu se zápisem nového prodejce
  clickOnAddVendor = () ->
    if $dlgAddVendor.data("loaded") isnt "true"
      App.progressShow()
      $.post(options.urlVendorDlgHtml).fail(App.showAjaxFail).done (data) ->
        App.progressHide()
        if data.error
          App.error(data.msg)
        else
          $dlgAddVendor.find(".btn-primary").click clickOnSaveVendor
          $fmVendor.empty().append(data.data)
          $dlgAddVendor.modal("show")
          validator = $fmVendor.validate
            ingnore: []
          $dlgAddVendor.data "loaded", "true"
          $dlgAddVendor.on "shown.bs.modal", () ->
            $fmVendor.find("[name=Surname]").focus()
          $dlgAddVendor.on "hidden.bs.modal", () ->
            validator.resetForm()
            $fmVendor.find("input[type=text], textarea").val("")
            $fmVendor.find(".has-error").removeClass("has-error")
          $isFirmVendor = $dlgAddVendor.find("#IsFirm")
          $isFirmVendor.click clickOnFirmVendor
        return
    else
      $dlgAddVendor.modal "show"
    return

  # kliknutí na tlačítko pro uložení nového prodejce
  clickOnSaveVendor = () ->
    if $fmVendor.valid()
      url = $fmVendor.attr "action"
      App.progressShow()
      $.post(url, $fmVendor.serialize()).fail(App.showAjaxFail).done(afterSaveVendor)
    return

  # událost po uložení prodejce
  afterSaveVendor = (data) ->
    App.progressHide()
    if data.error
      $msg = $("<div class='text-danger'/>").html(data.msg)
      if data.allErrors
        $ul = $("<ul/>")
        $.each data.allErrors, (idx, v) ->
          $li = $("<li/>").html(v.ErrorMessage)
          $ul.append($li)
        $msg.append($ul)
      $wrap = $("<div/>")
      $wrap.append($msg)
      App.alert $wrap.html()
    else
      $fmEdit.find("[name=IDVendor]").val data.model.IDOwner
      displayName = if data.model.FirmName == null then data.model.Surname + " " + data.model.Name else data.model.FirmName
      $findVendor.select2 "data",
        id: data.model.IDOwner
        label: displayName
      $dlgAddVendor.modal "hide"
    return

  # inicializuje opětovné načtení původního majitele, pokud byl změněn
  initOldOwnerBike = (elementId) ->
    return if !options.allowEdit
    $el = $("#" + elementId)
    $el.click (e) ->
      e.preventDefault()
      idOld = "" + $el.data("idowner")
      if $fmEdit.find("#IDOwner").val() isnt idOld
        loadOwner idOld, loadOwnerAfter
      return
    return

  # inicializuje vyhledávání v již existujících majitelích
  initFindOwnerBike = (elementId) ->
    return if !options.allowEdit
    $findOwnerBike = $("#" + elementId)
    $findOwnerBike.closest(".form-group").find("button").click(findOwnerBikeClear)
    $findOwnerBike.select2
      #theme: "bootstrap"
      minimumInputLength: 2
      width: "off"
      ajax:
        url: options.urlOwners
        dataType: "json"
        type: "GET"
        quietMillis: 250
        data: (term, page) ->
          return { term: term }
        results: (data, page) ->
          return { results: data.data }
      formatResult: (option) ->
        return "<div><strong>#{option.label}</strong>, #{option.address}</div>"
      formatSelection: (option) ->
        loadOwner(option.id, loadOwnerAfter)
        return option.label
    return

  # přepnutí s fyzické osoby na firmu nebo naopak
  isFirmOwnerChange = (e) ->
    console.log "Is firm on owner"
    state = $isFirmOwner.prop "checked"
    $fmEdit.find("[data-firm]").find("input:text").prop("disabled", !state)
    $fmEdit.find("[data-person]").find("input:text").prop("disabled", state)
    return

  # vyčistí fomulářové prvky obsahující data majitele
  findOwnerBikeClear = () ->
    if $(@).find(".glyphicon-remove").length > 0
      $div = $findOwnerBike.closest ".form-group"
      $div.find(".glyphicon-remove").removeClass("glyphicon-remove").addClass("glyphicon-search")
      $div.find("label").removeClass("text-danger").text txt.Search
      $els = $fmEdit.find("#Owner input:text")
      $els.each () -> $(@).val ""
      $els = $fmEdit.find("#Owner select")
      $els.each () -> $(@).val ""
      $fmEdit.find("[name='OwnerBike.IDOwner']").val ""
      $fmEdit.find("#IDOwner").val ""
      $fmEdit.find("[name='OwnerBike.IsFirm']").prop "checked", false
      $findOwnerBike.select2 "val", ""
      isFirmOwnerChange(null)
    return

  # načte detailní data o daném majitel - dle zadaného ID
  loadOwner = (id, callbackAfter) ->
    url = options.urlOwnerDetail + "/" + id
    $.post(url).fail(App.showAjaxFail).done(callbackAfter)
    return

  # zobrazí načtená data majitele do příslušných input prvků
  loadOwnerAfter = (data) ->
    if data.error
      App.error(data.msg)
    else
      $.each data.data, (key, value) ->
        $el = $fmEdit.find("[name='OwnerBike.#{key}']")
        if $el.length > 0
          if key is "DateBirthday" and value
            $el.val helper.dateToString(value)
          else if $el.is(":checkbox")
            $el.prop "checked", value
          else
            $el.val value
      $fmEdit.find("#IDOwner").val data.data.IDOwner
      isFirmOwnerChange(null)
      $div = $findOwnerBike.closest ".form-group"
      $div.find(".glyphicon-search").removeClass("glyphicon-search").addClass("glyphicon-remove")
      $div.find("label").addClass("text-danger").text txt.OwnerChangeTo
    return

  # inicializuje chovani zalozek dle typu - kolo, vozik, kocarek,...
  initBikeTypeTabs = () ->
    $typeProps = $fmEdit.find("#props").find(".type-prop")
    $typeProps.each ->
      $this = $(@)
      $tab = $("#" + $this.data("id"))
      if !$tab.is(".active")
        $this.find("input, select").prop( "disabled", true)
      return
    return

  # inicializace dialogu pro zapis nove vlastnosti do ciselniku
  initPropDialog = () ->
    $fmAddProp = options.$dlgAddProp.find("form")
    return if !options.allowEdit
    $fmAddPropValidator = $fmAddProp.validate()
    # inicializace tlacitek pro zobrazeni dialogu se zadanim nove vlastnosti
    $fmEdit.find(".input-group .add-prop").not(".add-vendor").click clickOnAddProp
    # napojeni kliknuti mysi na potvrzovaci tlacitko
    options.$dlgAddProp.find(".btn-primary").click clickSaveAddProp
    # tlacitko ENTER vyvola ulozeni
    options.$dlgAddProp.find("input:text").keypress (e) ->
      if e.keyCode is 13
        e.preventDefault()
        clickSaveAddProp(e)
      return
    # pri zobrazeni focusnu na input
    options.$dlgAddProp.on "shown.bs.modal", () -> options.$dlgAddProp.find("input:text").focus()
    # pri zavirani smazu chyby
    options.$dlgAddProp.on "hidden.bs.modal", () ->
      $fmAddPropValidator.resetForm()
      $fmAddProp.find(".has-error").removeClass("has-error")
    return

  clickOnAddProp = (e) ->
    e.preventDefault()
    $this = $(e.target)
    lb = $this.closest(".form-group").find("label").first().text()
    $selectedPropInput = $this.closest(".input-group").find("select")
    $fmAddProp.find("[name=action]").val($selectedPropInput.attr("name"))
    $fmAddProp.find("[name=Name]").val("")
    options.$dlgAddProp.find(".modal-title").text lb
    options.$dlgAddProp.modal "show"
    return

  clickSaveAddProp = (e) ->
    e.preventDefault()
    if $fmAddProp.valid()
      postVar = $fmAddProp.serialize()
      App.progressShow()
      $.post($fmAddProp.attr("action"), postVar).fail(App.showAjaxFail).done(afterSaveAddProp)
    return
  # po ulozeni nove hodnoty vlastnosti do cisleniku
  afterSaveAddProp = (data) ->
    App.progressHide()
    if data.error
      App.error(data.msg)
    else
      options.$dlgAddProp.modal "hide"
      $opt = $("<option/>").val(data.data.ID).text(data.data.Name)
      $selectedPropInput.append($opt)
      $selectedPropInput.val(data.data.ID)
    return

  # zmena stavu predmetu - odcizeno, ztraceno,...
  changeState = () ->
    $this = $(@)
    $liTab = $fmEdit.find("#StateExtendTab")
    idState = parseInt($this.val(), 10)
    txt = $this.find("option:selected").text()
    if idState > 1
      $liTab.find("span").text(txt)
      $liTab.show()
    else
      $liTab.hide()

    return

  clickOnFirmVendor = () ->
    console.log "Is firm on vendor"
    return if $isFirmVendor is null
    if $isFirmVendor.prop("checked")
      $dlgAddVendor.find("[data-person]").find("input:text").prop("disabled", true)
      $isFirmVendor.closest("#firm").find("input:text").prop("disabled", false)
    else
      $dlgAddVendor.find("[data-person]").find("input:text").prop("disabled", false)
      $isFirmVendor.closest("#firm").find("input:text").prop("disabled", true)
    return

  showTabProp = ($sender) ->
    id = $sender.attr('href')
    $tab = $(id)
    $panel = $tab.closest(".panel")
    $panel.find(".tab-pane").not(id).each () ->
      $(this).find("input, select").prop("disabled", true)
      $(this).find(".required").removeClass("required")
    $tab.find("input, select").prop("disabled", false)
    $tab.find("[data-required]").addClass("required")
    $fmAddProp.find("[name=Kinds]").val($sender.data("kinds"))
    $fmAddProp.find("[name=Kind]").val($sender.data("kinds"))
    $fmEdit.find("[name=KindCode]").val $sender.data("kinds")
    return

  # validace dat zadanych do formulare
  validate = () ->
    stav = true
    $(".form-group.has-error").removeClass("has-error")
    if !$fmEdit.valid()
      stav = false
    #console.log("validate => " + stav)
    return stav

  # po odeslani udaju na server se vyhodnoti zda vse probehlo v poradku nebo ne
  btnSaveAfter = (data) ->
    # nastala chyba, tak zobrazim detailni vypis
    if data.error
      App.progressHide()
      $msg = $("<div class='text-danger'/>").html(data.msg)
      if data.allErrors
        $ul = $("<ul/>")
        $.each data.allErrors, (idx, v) ->
          $li = $("<li/>").html(v)
          $ul.append($li)
        $msg.append($ul)
      $wrap = $("<div/>")
      $wrap.append($msg)
      App.alert $wrap.html()
    else
      # vse probehlo OK, tak zpět na index
      if !closeAfterSave
        window.location.href = options.urlIndex
      else
        if $("#ID").val() is ""
          tmp = window.location.href.split("#")
          url = tmp[0] + "/" + data.data.ID
          url += "#" + tmp[1] if tmp.length > 1
          window.location.href = url
        else
          App.progressHide()
    return

  # tlacitko pro ulozeni udaju
  btnSaveClick = (e) ->
    return if !options.allowEdit
    e.preventDefault()
    if validate()
      arr = $fmEdit.serializeArray();
      App.progressShow()
      closeAfterSave = $(@).is("#btn-save-noclose")
      $.post($fmEdit.attr("action"), arr).fail(App.showAjaxFail).done(btnSaveAfter)
    else
      $msg = $("<div class='text-danger'/>").text(txt.error_validate)
      $ul = $("<ul/>")
      $(".form-group.has-error").each ->
        $li = $("<li/>").text($(@).find("label").text())
        $ul.append($li)
        return
      $msg.append($ul)
      $wrap = $("<div/>")
      $wrap.append($msg)
      App.alert $wrap.html()
    return false

  # odešle asynchronně obrázek kola na server
  uploadImage = (idx, file, sizeF) ->
    fmData = new FormData
    guidEditor = options.guidEditor
    fmData.append "Index", idx
    fmData.append "GuidEditor", guidEditor
    fmData.append "file", file
    $("#imgThmb-" + idx).prop("src", options.imgAjaxUploader).addClass "upload"
    $.ajax
      type: "POST"
      url: options.urlImgUpload
      data: fmData
      success: (data) ->
        $("#imgThmb-" + idx).prop("src", options.urlImage + "?guid=#{guidEditor}&index=#{idx}&r=#{Math.random()}").removeClass "upload"
        $("#imgThmb-" + idx).closest(".foto").find("[data-del-photo]").prop("disabled", false)
        return
      error: (xhr, status, err) ->
        App.progressHide()
        $("#imgThmb-" + idx).prop("src", options.urlImage + "?guid=#{guidEditor}&index=#{idx}&r=#{Math.random()}").removeClass "upload"
        App.alert txt.PhotoSizeOverflow.replace("#SIZE-FOTO#",sizeF).replace("#SIZE#", "#{maxPhotoSize.width} x #{maxPhotoSize.height}")
        return
      processData: false
      contentType: false
    return

  # kontrola zda uploadovana fotka neni prilis velka
  checkPhotoSizeAndUpload = (idx, file) ->
    if file
      fileType = file["type"]
      if $.inArray(fileType, ["image/gif", "image/jpeg", "image/png"]) < 0
        App.alert txt.FileIsNotImage
        return
      img = new Image()
      #console.log(file)
      img.src = window.URL.createObjectURL( file )
      img.onload = () ->
        width = img.naturalWidth
        height = img.naturalHeight
        window.URL.revokeObjectURL( img.src )
        #console.log("#{width} x #{height}")
        sizeF = "#{width} x #{height}"
        uploadImage idx, file, sizeF
        return
    return

  # událost při změně/výběru fotky pro upload na server - provede kontrolu a pak ajax odeslání na server
  changePhoto = () ->
    if typeof this.files is "undefined"
      App.alertBrowser()
      return
    idx = $(@).closest("div.foto").data "idx"
    checkPhotoSizeAndUpload idx, this.files[0]
    return

  # událost kliku na tlačítko pro smazání fotky
  clickDeltePhoto = (e) ->
    e.preventDefault()
    idx = $(@).data("del-photo")
    removePhoto idx
    return

  # odstraní danou fotku
  removePhoto = (idx) ->
    guidEditor = options.guidEditor
    $.ajax
      type: "POST"
      url: options.urlImgRemove
      data: "Index=#{idx}&GuidEditor=#{guidEditor}"
      success: (data) ->
        if data.error
          App.alert data.msg
        else
          $("#imgThmb-" + idx).prop("src", options.srcEmptyImg)
          $("#imgThmb-" + idx).closest(".foto").find("[data-del-photo]").prop("disabled", true)
        return
      error: App.showAjaxFail
    return