﻿# CoffeeScript
class @BikesClass
  options =
    allowEdit: false
    editUrl: null
    printUrl: null
    deleteFullUrl: null
    deleteUrl: null
    syncUrl: null
    miniImgUrl: null
    urlImage: null

  $SpeedFiltr = null
  $trSelected = null
  table = null
  $tbl = null
  stateIcons = ['', 'Register', 'Deregister', 'Stolen', 'Lose', 'Deleted' ]

  constructor: (opt) ->
    options = opt
    initFiltr()
    initTable()
    initCentralSync()

    $("#btFiltr").click (e) ->
      e.preventDefault()
      $("#dlg-filtr").modal "show"
      return

    # pri zmene velikosti okna prekreslit znovu tabulku
    $(window).resize ->
        $tbl.dataTable().fnDestroy();
        initTable()

    $(document).on 'click', '[data-toggle="lightbox"]', (event) ->
        event.preventDefault();
        $(@).ekkoLightbox();
        return

    $(document).keydown shortcutCase

    return

  $fmFiltr = -> $("#fmFiltr")

  # vyvolání akce po stisku zkratkové klávesy - otevření URL dle href nastaveném v elementu
  shortcutOpenUrl = (e, id) ->
    $a = $(id)
    window.location.href = $a.attr("href");
    return;

  # řešení pro použití zkratkových kláves
  shortcutCase = (e) ->
    shortcutOpenUrl(e, "#btNew") if e.keyCode is 45 and !e.ctrlKey
    return

  # odesle oznacene polozky do centralniho registru
  clickButtonToCentral = (e) ->
    e.preventDefault()
    return if !options.allowEdit
    $marked = $("#tbl-data-bike tbody").find("input:checked")
    if $marked.length is 0
      App.alert txt.send_central_empty
      return false
    marks = new Array()
    $marked.each () ->
      marks.push
        name: "MarksID"
        value: @.value
      return
    App.question txt.send_central_question, () ->
      App.progressShow()
      $.post(options.syncUrl, marks).done(afterSyncCentral).fail(App.showAjaxFail)
      return
    return false

  # inicializuje podporu pro synchronizaci s centr8lou
  initCentralSync = () ->
    return if !options.allowEdit
    $("#btSendCentral").click clickButtonToCentral
    return

  # událost po odeslání označených záznamů na centrálu
  afterSyncCentral = (data) ->
    App.progressHide()
    # projdu všechny ID, které byly poslány ke zpracování a server je vrátil s výsledkem zpět
    $errList = $("<ul/>")
    for d in data.data
      do (d) ->
        $li = $("<li/>").text(d.message)
        $errList.append($li)
        $el = $("#cbBike-#{d.id}")
        $img = $el.closest("tr").find("img.state-central")
        ico = "#{configJS.url}/Content/images/ikona-#{d.state}.png"
        if !d.error
          $img.attr("src", ico).attr("title",txt.syncOkHint).attr("alt", "SyncOk")
        else
          $img.attr("src", ico).attr("title",txt.syncErrHint)
        $el.prop("checked",false)

    if data.error
      $msg = $("<div/>").text(data.msg)
      $msg.append $errList
      App.error $msg
    else
      App.alert(txt.send_central_ok)
    return

  # udalost pred odeslanim filtru ajaxem na server
  getFiltrData = (d) ->
    if $SpeedFiltr is null
      $SpeedFiltr = $("#tbl-data-bike_filter input")
    $fm = $fmFiltr()
    #ord_0 = d.order[0]
    start = false
    data = $fm.serializeObject()
    data["SpeedFiltr"] = $SpeedFiltr.val()
    data["Start"] = d.start
    data["Length"] = d.length
    data["State"] = $fm.find("[name=State]").val()
    data["KindCode"] = $fm.find("[name=KindCode]").val()
    data["StateCentral"] = $fm.find("[name=StateCentral]").val()
    if d.order && d.order.length > 0
      ord = d.columns[d.order[0].column].data
      data["Order"] = ord
      data["OrderDir"] = d.order[0].dir
    return data

  # vygeneruje checkbox pro oznaceni v tabulce z koly
  checkboxInTable = (id, regNumber) ->
    html = "<input id='cbBike-#{id}' type='checkbox' class='marked' value='#{id}' autocomplete='off' /> <label for='cbBike-#{id}'>#{regNumber}</label>"
    return html
  # vygeneruje obrazek druhu (kol, vozik,...) v tabulce
  kindToImageHtml = (kindName, code) ->
    url = "#{configJS.url}Content/images/ikona-#{code}.png?v=1"
    return "<img src='#{url}' alt='#{code}' title='#{kindName}' />"
  # vygeneruje obrazek statusu v tabulce
  stateToImageHtml = (stateText, state) ->
    url = "#{configJS.url}Content/images/ikona-#{state}.png?v=1"
    return "<img src='#{url}' alt='#{state}' title='#{stateText}' />"
  # vygeneruje obrazek centralniho statusu v tabulce
  stateCentralToImageHtml = (stateText, state) ->
    url = "#{configJS.url}Content/images/ikona-#{state}.png?v=1"
    return "<img class='state-central' src='#{url}' alt='#{state}' title='#{stateText}' />"
  cellDrawRegNumber = (nTd, sData, oData, i) ->
    $(nTd).html(checkboxInTable(oData.ID, sData))
  # vykresleni sloupce se statusem
  cellDrawState = (nTd, sData, oData, i) ->
    html = stateToImageHtml(sData, oData.StateBike)
    txt = oData.StateCentralHint + " (" + helper.dateTimeToString(oData.DateCentral) + ")"
    html += stateCentralToImageHtml(txt, oData.StateCentral)
    $(nTd).html(html)

  cellDarwKind = (nTd, sData, oData, i) ->
    html = kindToImageHtml(oData.KindName, sData)
    $(nTd).html(html)

  cellDrawRegDate = (nTd, sData, oData, i) ->
    $(nTd).closest("tr").data "id", oData.ID
    $(nTd).text helper.dateToString(sData)

  cellDrawPrice = (nTd, sData, oData, i) ->
    if sData != null
      $(nTd).text(numeral(sData).format('0,0[.]00') + " " + configJS.currency)

  cellDrawActions = (nTd, sData, oData, i) ->
    $td = $(nTd)
    $td.parent().data "id", oData.ID
    if options.allowEdit
      cssClass = if oData.StateBike is "Deleted" then " del-full" else "-o del"
      html = "&nbsp;&nbsp;&nbsp;<a hreaf='javascript:;'><i class='fa fa-trash#{cssClass}'></i></a>"
    else
      html = ""
    html = "<a href='#{options.printUrl}/#{oData.ID}' target='_blank'><i class='fa fa-print print'></i></a>" + html
    $td.html html   

  # zobrazení v jednoduchém režimu
  cellDrawSimple = (nTd, sData, oData, i) ->
    $td = $(nTd)
    stateImg = stateToImageHtml(oData.State, oData.StateBike)
    kindImg = kindToImageHtml(oData.KindName, oData.KindCode)
    $owner = $("<div class='text-info'></div>").text(oData.Majitel)
    
    html = stateImg + kindImg + " " + oData.KindName + ": "
    $td.html html

    $sn = $("<span class='text-success'></span>").text(" " + oData.FrameNumber)
    $td.append $sn

    $regPlace = $("<span></span>").html(" (" + oData.RegPlace + ": <small class='text-muted'><em>" + helper.dateToString(oData.RegDate) + "</em></small>)")	
    $td.append $regPlace

    $td.append $owner  

    if oData.CodeMicro
        $dna = $("<span/>").append(oData.CodeType + ": ").append(oData.CodeMicro + " ")
        $td.append $dna

    if oData.Price
        $price = $("<span class='price'/>").text(window.txt.price)    
        $price.append(" <strong>" + numeral(oData.Price).format('0,0[.]00') + " " + configJS.currency + ",-</strong>")           
        $td.append $price

  # vygeneruje checkbox pro oznaceni v tabulce s koly a take stav centraly a mini obrazek
  cellDrawRegNumberSimple = (nTd, sData, oData, i) ->
    $td = $(nTd).empty().addClass("reg-img no-edit")
    txt = oData.StateCentralHint
    if oData.DateCentral
        txt + " (" + helper.dateTimeToString(oData.DateCentral) + ")"
    state = stateCentralToImageHtml(txt, oData.StateCentral)
    $divLeft = $("<div class='pull-left no-edit'/>")
    $divLeft.append("<input id='cbBike-#{oData.ID}' type='checkbox' class='marked no-edit' value='#{oData.ID}' autocomplete='off' /> <label class='no-edit' for='cbBike-#{oData.ID}'>#{oData.RegNumber}</label><br/><label class='no-edit' for='cbBike-#{oData.ID}'>#{state}</label>")
    $divRight = $("<div class='pull-right no-edit'/>")
    $a = $("<a data-toggle='lightbox' />").attr("href", "#{options.urlImage}?index=0&idBike=#{oData.ID}&thumb=false")
    $a.append($("<img class='img-rounded' />").attr("src", options.miniImgUrl + "?idBike=" + oData.ID))
    $divRight.append($a)
    $td.append($divLeft)
    $td.append($divRight)

  clickTableRow = (e) ->
    $tr = $(this)
    $target = $(e.target)
    $trSelected = $target.closest("tr")
    if $target.is "input.marked"
      return
    else if $target.is ".print"
      return
    else if $target.is ".del"
      e.preventDefault()
      $trSelected.addClass("selected")
      App.question txt.delete_question, deleteRec, null, ->
        $trSelected.removeClass("selected")
      return
    else if $target.is ".del-full"
      e.preventDefault()
      $trSelected.addClass("selected")
      App.question txt.delete_question, deleteRecFull, null, ->
        $trSelected.removeClass("selected")
    else if $target.is "img"
        return
    else if $target.is ".no-edit"
        return
    else
      e.preventDefault()
      window.location.href = options.editUrl + "/" + $tr.data("id")
    return

  # oznaci polozku jako zrusenou
  deleteRecBase = (full) ->
    id = $trSelected.data "id"
    App.progressShow()
    $.ajax
      type: "POST"
      url: options.deleteUrl
      data: "id=#{id}&full=#{full}"
      error: App.showAjaxFail
      success: (data) ->
        App.progressHide()
        if data.error
          App.alert data.msg
        else
          table.row($trSelected).remove().draw(false)
        return
    return

  deleteRec = () -> deleteRecBase(false)

  deleteRecFull = () -> deleteRecBase(true)

  formStatus = (d) ->
    $item = ''
    id = parseInt(d.id, 10)
    if id > 0
      icon = configJS.url + "/Content/images/ikona-" + stateIcons[id] + ".png?v=1"
      $item = $("<span><img src='#{icon}'/> #{d.text}</span>")
    return $item

  formKindCode = (d) ->
    icon = configJS.url + "/Content/images/ikona-" + d.id + ".png?v=1"
    $item = $("<span><img src='#{icon}'/> #{d.text}</span>")
    return $item

  formCentralStatus = (d) ->
    icon = "#{configJS.url}Content/images/ikona-#{d.id}.png?v=1"
    $item = $("<span><img src='#{icon}'/> #{d.text}</span>")
    return $item    

  # příznak jestli je zapnuto jednoduché zobrazení tabulky
  isSimpleView = () ->
    state = Cookies.get("BikeTblSimple") 
    return state isnt "disable" 

  # prepinani vzhledu/vypisu polozek v tabulce - bud detailni anebo zjednoduseny
  changeSimpleView = (e) ->
    e.preventDefault()    
    state = if isSimpleView() then "disable" else "enable"
    Cookies.set('BikeTblSimple', state)    
    window.location.reload()
    return

  # inicializace filtru
  initFiltr = () ->
    $("#simple-view").click changeSimpleView
    $fm = $fmFiltr()
    $el = $fm.find("select[name=State]")
    $el.select2
      allowClear: true
      placeholder: $el.data("placeholder")
      formatResult: formStatus
      formatSelection: formStatus

    $el = $fm.find("select[name=KindCode]")
    $el.select2
      allowClear: true
      placeholder: $el.data("placeholder")
      formatResult: formKindCode
      formatSelection: formKindCode

    $el = $fm.find("select[name=StateCentral]")
    $el.select2
      allowClear: true
      placeholder: $el.data("placeholder")
      formatResult: formCentralStatus
      formatSelection: formCentralStatus

    $fm.find("select").on "change", (e) -> table.ajax.reload()
    return

  initTable = () ->
    $tbl = $("#tbl-data-bike")
    $fm = $fmFiltr()

    if !isSimpleView()
        cols = [
          { mData: "RegNumber", sWidth: 50, fnCreatedCell: cellDrawRegNumber }
          { mData: "State", sClass: "State t-c", sWidth: 50, fnCreatedCell: cellDrawState }
          { mData: "KindCode", sClass: "KindCode t-c", sWidth: 50, fnCreatedCell: cellDarwKind }
          { mData: "Gender", sClass: "visible-lg" }
          { mData: "Type", sClass: "visible-lg" }
          { mData: "RegDate", sClass: "t-r", fnCreatedCell: cellDrawRegDate, sClass: "visible-lg" }
          { mData: "Majitel" }
          { mData: "CodeMicro", sClass: "visible-lg" }
          { mData: "FrameNumber" }
          { mData: "Color", sClass: "visible-lg" }
          { mData: "Price", sClass: "t-r visible-lg", fnCreatedCell: cellDrawPrice }
          #{ mData: "Registroval" }
          { mData: null, sClass: "t-c actions", sWidth: 40, bSortable: false, fnCreatedCell: cellDrawActions }
        ]
    else
        cols = [
            { mData: "RegNumber", sWidth: 100, fnCreatedCell: cellDrawRegNumberSimple }
            { mData: "SimpleCol", fnCreatedCell: cellDrawSimple }
            { mData: null, sClass: "t-c actions", sWidth: 40, bSortable: false, fnCreatedCell: cellDrawActions }
        ]

    aoColumnDefs = []
    for cl, i in cols
      cl.aTargets = i
      aoColumnDefs.push cl

    opt =
      responsive: true
      aoColumnDefs: aoColumnDefs
      searching: true
      serverSide: true
      processing: true
      ajax:
        url: $fm.attr("action")
        type: "POST"
        data: getFiltrData

    $th = $tbl.find("thead tr").empty()
    for cl in aoColumnDefs      
      cssClass = if cl.bSortable isnt false then "sorting" else ""
      $th.append $("<th aria-controls='tbl-data-bike' class='#{cssClass}'/>").text(txt[cl.mData])

    # inicializace tabulky
    #table = $tbl.DataTable()
    #$tbl.DataTable helper.tableDefOpt(opt)
    table = $tbl.DataTable helper.tableDefOpt(opt)
    $tbl.find("tbody").on "click", "tr", clickTableRow
    return
