﻿class BikeTypesClass
    constructor: ->
        $trSelected = null
        $fmEdit = $("#fmEdit");
        $dlgEdit = $("#dlgEdit")
        $validate = $fmEdit.validate()

        opt =	
            responsive: true			
            aoColumnDefs: [
                {
                    aTargets: [0]
                    sClass: "kind"					
                }
                {
                    aTargets: [1]
                    sClass: "name"					
                }
                {
                    aTargets: [2]
                    sClass: "del text-center"
                    bSortable: false
                }
            ]

        # inicializace tabulky
        table = $("#tblData").dataTable helper.tableDefOpt(opt)
        
        $dlgEdit.on "shown.bs.modal", (e) -> 
            $fmEdit.find("[name=Name]").focus()
            return
        $dlgEdit.on "hidden.bs.modal", (e) -> 			
            helper.resetValidError $fmEdit, $validate
            
        $("#dlgEdit-save").click (e) ->
            e.preventDefault()
            saveData()
            return			

        loadEdit = (id) ->
            App.progressShow()
            $.ajax
                type: "POST"
                url: "Service/Manufacturer"
                data: "id=#{id}&action=bikeframe-detail"
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        $fmEdit.find("[name=Name]").val data.data.Name
                        $fmEdit.find("[name=ID]").val data.data.ID
                        $fmEdit.find("#KindCode-#{data.data.Kind}").prop("checked",true);
                        $dlgEdit.modal("show")
                        $dlgEdit.find("h4").text data.data.Name
                    return			
            return

        saveData = ->
            return false if !$fmEdit.valid()
            App.progressShow()
            $.ajax
                type: "POST"
                url: "Service"
                data: $fmEdit.serialize()
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        window.location.reload()
                    return
            return

        $("#btNew").button().click ->
            $trSelected = null
            $fmEdit.find("[name=Name], [name=ID]").val("")
            $fmEdit.find("#KindCode-0").prop("checked",true);
            $dlgEdit.modal("show")
            $dlgEdit.find("h4").text $(@).text()
            return false

        $("#tblData").find("tbody").on "click", "td", (evn) ->
            $target = $(evn.target)
            $trSelected = $target.closest("tr")
            if $target.is(".del")
                $trSelected.addClass("selected")
                App.question txt.delete_question, deleteRec, null, ->
                    $trSelected.removeClass("selected")
            else				
                loadEdit $trSelected.data("id")
            return

        deleteRec = ->
            id = $trSelected.data "id"
            App.progressShow()
            $.ajax
                type: "POST"
                url: "Service/ListCodes"
                data: "id=#{id}&action=bikeframe-del"
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        table.fnDeleteRow($trSelected[0])
                    return
            return

$ ->
    new BikeTypesClass
    return