﻿# CoffeeScript
class MicroCodes
    constructor: ->
        $trSelected = null
        $fmEdit = $("#fmEdit");
        $dlgEdit = $("#dlgEdit")
        $validate = $fmEdit.validate()
        
        opt =			
            responsive: true
            aoColumnDefs: [
                {
                    aTargets: [0]
                    sClass: "Active  text-center"
                    width: 50
                }
                {
                    aTargets: [1]
                    sClass: "Code"
                }
                {
                    aTargets: [2]
                    sClass: "Micro"
                }
                {
                    aTargets: [3]
                    sClass: "Date"
                    width: 120
                }
                {
                    aTargets: [4]
                    sClass: "del text-center"
                    bSortable: false
                }
            ]


        # inicializace tabulky
        table = $("#tblData").dataTable helper.tableDefOpt(opt)
        
        $dlgEdit.on "shown.bs.modal", (e) -> 
            $fmEdit.find("[name=Code]").focus()
            return
        $dlgEdit.on "hidden.bs.modal", (e) -> 			
            helper.resetValidError $fmEdit, $validate			
            
        $("#dlgEdit-save").click (e) ->
            e.preventDefault()
            saveData()
            return	
                    
        loadEdit = (id) ->
            App.progressShow()
            $.ajax
                type: "POST"
                url: "Service/MicroCode"
                data: "id=#{id}&action=microcodes-detail"
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        $fmEdit.find("[name=Code]").val data.data.Code
                        $fmEdit.find("[name=ID]").val data.data.ID
                        $fmEdit.find("[name=CodeMicro]").val data.data.CodeMicro
                        $fmEdit.find("[name=Active]").prop("checked", data.data.Active);
                        $dlgEdit.modal("show")
                        $dlgEdit.find("h4").text data.data.Name
                    return			
            return							
        
        saveData = ->
            return false if !$fmEdit.valid()
            App.progressShow()
            $.ajax
                type: "POST"
                url: "Service"
                data: $fmEdit.serialize()
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        window.location.reload()
                    return
            return
                    
        $("#btNew").button().click ->
            $trSelected = null
            $fmEdit.find("[name=CodeMicro], [name=Code], [name=ID]").val("")
            $fmEdit.find("[name=Active]").prop("checked", true);
            $dlgEdit.modal("show")
            $dlgEdit.find("h4").text $(@).text()
            return false	
            
        $("#tblData").find("tbody").on "click", "td", (evn) ->
            $target = $(evn.target)
            $trSelected = $target.closest("tr")
            return if $target.is ".dataTables_empty"
            if $target.is(".del")
                $trSelected.addClass("selected")
                App.question txt.delete_question, deleteRec, null, ->
                    $trSelected.removeClass("selected")
            else				
                loadEdit $trSelected.data("id")
            return	
            
        deleteRec = ->
            id = $trSelected.data "id"
            App.progressShow()
            $.ajax
                type: "POST"
                url: "Service/ListCodes"
                data: "id=#{id}&action=microcodes-del"
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        window.location.reload()
                    return
            return
                                                        
        ### KONEC ###
        return
        
$ ->
    new MicroCodes
    return		