﻿# CoffeeScript
class @OwnersClass
  options =
    allowEdit: false
    editUrl: null
    deleteUrl: null

  $SpeedFiltr = null
  $trSelected = null
  table = null
  $tbl = null
  $fmFiltr = null

  constructor: (opt) ->
    options = opt

    $fmFiltr = $("#fmFiltr")

    $el = $fmFiltr.find("select[name=LogLevel]")
    $el.select2
      allowClear: true
      placeholder: $el.data("placeholder")

    $fmFiltr.find("select").on "change", (e) -> table.ajax.reload()

    # pri zmene velikosti okna prekreslit znovu tabulku
    $(window).resize ->
        $tbl.dataTable().fnDestroy();
        initTable()

    initTable()
    return

  cellDrawActive = (nTd, sData, oData, i) ->
    stav = if oData.IsActive then "ok text-success" else "remove text-muted"
    html = "<span class='glyphicon glyphicon-#{stav}'></span>"
    $(nTd).addClass("text-center").html(html)
    $(nTd).closest("tr").data("id", oData.ID)

  cellDrawFullname = (nTd, sData, oData, i) ->
    stav = if oData.IsActive then "" else "text-muted"
    full = oData.Fullname
    if oData.FirmName
      full = "#{full} [#{oData.FirmName}]"
    $(nTd).addClass(stav).text(full)

  cellDrawFullnameSimple = (nTd, sData, oData, i) ->
    $td = $(nTd)
    stav = if oData.IsActive then "" else "text-muted"
    $full = $("<div/>").append(oData.Fullname)
    $addr = $("<div/>").append(oData.Address)    
    if oData.FirmName
      $full.append( $("<span/>").text( " [#{oData.FirmName}]"))
    $td.empty().addClass(stav).append($full).append($addr).append($cont)
    if oData.Phone
      $cont = $("<div class='glyphicon glyphicon-earphone'/>").append(oData.Phone)
      $td.append($cont)

  cellDrawPhone = (nTd, sData, oData, i) ->
    if oData.Phone
      $(nTd).addClass("").html( "<span class='glyphicon glyphicon-earphone'> #{oData.Phone}</span>")
    else
      $(nTd).addClass("").text("")

  # udalost pred odeslanim filtru ajaxem na server
  getFiltrData = (d) ->
    if $SpeedFiltr is null
      $SpeedFiltr = $("#tbl-data_filter input")
    data = $fmFiltr.serializeObject()
    data["Start"] = d.start
    data["Length"] = d.length
    data["SpeedFiltr"] = $SpeedFiltr.val()
    if d.order && d.order.length > 0
      ord = d.columns[d.order[0].column].data
      data["Order"] = ord
      data["OrderDir"] = d.order[0].dir
    return data

  tableClick = (e) ->
    $target = $(e.target)
    $tr = $target.closest("tr")
    if options.allowEdit
        window.location.href = options.editUrl + "/" + $tr.data("id")
    return

  initTable = () ->
    $tbl = $("#tbl-data")
    

    cols = [
      { mData: "IsActive", sWidth: 50, fnCreatedCell: cellDrawActive }
      { mData: "Fullname", fnCreatedCell: cellDrawFullname, sClass: "hidden-md hidden-sm hidden-xs" }
      { mData: "Fullname", fnCreatedCell: cellDrawFullnameSimple, sClass: "hidden-lg" }
      { mData: "Address", sClass: "hidden-md hidden-sm hidden-xs" }
      { mData: "Phone", fnCreatedCell: cellDrawPhone, sClass: "hidden-md hidden-sm hidden-xs" }
    ]

    aoColumnDefs = []
    for cl, i in cols
      cl.aTargets = i
      aoColumnDefs.push cl

    opt =
      responsive: true
      aoColumnDefs: aoColumnDefs
      searching: true
      serverSide: true
      processing: true
      ajax:
        url: $fmFiltr.attr("action")
        type: "POST"
        data: getFiltrData

    $tbl.find("tbody").empty()
    $th = $tbl.find("thead tr").empty()
    for cl in aoColumnDefs
      cssClass = if cl.bSortable isnt false then "sorting" else ""
      $th.append $("<th aria-controls='tbl-data-bike' class='#{cssClass}'/>").text(txt[cl.mData])

    table = $tbl.DataTable helper.tableDefOpt(opt)
    $tbl.find("tbody").on "click", "td", tableClick

    return

  activateAll = ->
    afterActivate = (data) ->
      App.progressHide()
      if data.error
        App.error data.msg
      else
        table.ajax.reload()
      return

    url = $("#btActivateAll").attr("href")
    App.progressShow()
    $.post(url).done(afterActivate).fail(App.showAjaxFail)
    return

  # aktivuje všechny záznamy	
  $("#btActivateAll").button().click (evn) -> 
    evn.preventDefault()
    App.question txt.QuestionActivateOwners, activateAll
    return false