﻿# CoffeeScript
class OwnersClass
    constructor: ->
        $trSelected = null
        $fmEdit = $("#fmEdit")
        $fmFiltr = $("#fmFiltr")
        $validate = $fmEdit.validate()
        isAdmin = $("#hdIsAdmin").val() is "True"
        countryConf = $("#lbIdentityCard").data()

        if $("#filtr-active").length > 0
            $("#filtr-active").animate
                opacity: 0.5
                2000
                ->
                    $(this).remove()

        $("#Fullname").focus()

        opt =
            bFilter: false					
            aoColumns: [
                { mData: "Name" }
                { mData: "Surname" }
                { mData: "NumberBirthday" }
                { mData: "FirmName" }
                { mData: "Address" }
                { mData: "Phone" }
            ]
            aoColumnDefs: [
                {
                    aTargets: [0]
                    fnCreatedCell: (nTd, sData, oData, i) ->
                        $(nTd).closest("tr").data "id", oData.IDOwner
                }
            ]			
            bAutoWidth		: false
            bFilter			: false
            bPaginate		: true
            sDom			: "lptip"
            bInfo			: true
            bProcessing		: true
            serverSide		: true
            bStateSave      : false					# ukládat nastavení tabulky
            sPaginationType : "full_numbers"		# zobrazit navigaci pomocí čísel stránek
            oLanguage       : txt.dataTable			# textové překlady pro tabulku
            bJQueryUI       : false					# nepoužívat JQueryUI téma
            order			: [[1,"desc"]]
            pageLength		: $("#tblData").data("page-size")
            displayStart	: $("#tblData").data("page-start")
            aLengthMenu     :						# použitelné velikosti tabulky = výbr počtu zobrazených řádků
                [[10, 25, 50, -1], 
                [10, 25, 50, txt.all]]
            ajax: {
                url: $fmFiltr.attr("action")
                type: "POST"
                data: (d) ->
                    ord_0 = d.order[0]					
                    data =			
                        Fullname: $fmFiltr.find("[name=Fullname]").val()
                        NumberBirthday: $fmFiltr.find("[name=NumberBirthday]").val()
                        Address: $fmFiltr.find("[name=Address]").val()
                        Sort: d.columns[ord_0.column].data
                        Dir: ord_0.dir
                        Start: d.start
                        PageSize: d.length
                    start = false
                    return data
            }

        # inicializace datove tabulky
        table = $("#tblData").DataTable opt
        #table.fnSettings().exFilter = $fmFiltr
        #table.fnReloadAjax()
        # zrusim znacku ze jde o prvotni nacteni pri prichodu na stranku
        $fmFiltr.find("[name=FirstLoad]").val("")

        # datumy - vstup
        $fmEdit.find("input.date").datepicker()

        # tlacitko pro filtrovani dat - hledani
        $("#btFiltr").button().click (evn) -> 
            evn.preventDefault()
            table.ajax.reload()
            return false

        # nastavi vsechny editacni prvky pouze na cteni
        disableDialogEdit = () ->
            $fmEdit.find("input:text, input.number, textarea").prop("readonly",true)
            $fmEdit.find("select").prop("disabled",true).addClass("readonly")
            $fmEdit.find("#btKind").button("disable", true)
            return

        # dialog pro editaci majitele
        $dlgEdit = $("#dlgEdit").dialog
            autoOpen:false
            width:  $("#dlgEdit").width()
            modal:true
            open: -> 
                if !IsAllowEdit
                    disableDialogEdit()
                    
                $trSelected.addClass("selected") if $trSelected isnt null
                $validate.resetForm()
            close: -> 
                $trSelected.removeClass("selected") if $trSelected isnt null
            buttons: [
                {
                    text: txt.btn_ok
                    click: ->
                        if IsAllowEdit
                            saveData()
                        else
                            $(@).dialog "close"
                        return
                }
                {
                    text: txt.btn_cancel
                    click: -> $(@).dialog "close"
                }
            ]
            
        # pri zmene zeme zkontroluji jestli to je cizinec a pripadne nastavim zadavani cisla pasu
        $dlgEdit.find("#IDCountry").change (e) ->
            if @.value is countryConf.defaultId + ""
                $dlgEdit.find("#lbIdentityCard").text countryConf.txtOp + ":"
            else
                $dlgEdit.find("#lbIdentityCard").text countryConf.txtPas + ":"
            return	

        # vymaze vstupy na editacnim dialogu
        clearEditDialog = ->
            $fmEdit.find("input:text, input:hidden, select").val ""
            $fmEdit.find("input:checkbox").prop "checked", false
            return

        # ulozeni udaju o majiteli
        saveData = ->
            return false if !$fmEdit.valid()
            url = $fmEdit.prop "action"
            #App.alert "Tato funkce jeste neni implementovana."
            App.progressShow()
            $.ajax
                type: "POST"
                url: url
                data: $fmEdit.serialize()
                error: App.showAjaxFail
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else
                        table.draw false
                        $dlgEdit.dialog "close"

                    return
            return

        # nacteni detailu a otevreni editacniho dialogu
        loadEdit = (id) ->
            App.progressShow()
            $.ajax
                type: "post"
                url: $("#hdUrlOwnerEdit").val()
                data: "id=" + id
                success: (data) ->
                    App.progressHide()
                    if data.error
                        App.alert data.msg
                    else											
                        fillOwner data.data
                        $dlgEdit.dialog "option", "title", "#{data.data.Surname} #{data.data.Name}"
                        $dlgEdit.dialog "open"
                    return
                error: App.showAjaxFail
            return

        # vyplni editacni dialog nactenymi udaji ze serveru
        fillOwner = (owner) ->
            for key, value of owner
                $el = $fmEdit.find("[name=#{key}]")
                if key is "DateBirthday" 
                    $fmEdit.find("[name=#{key}]").val helper.dateToString(value)	
                else if $el.is ":checkbox"
                    $el[0].checked = value
                else if $el.is(":text") or $el.is(":hidden")
                    $el.val value				
            return			

        # zalozeni noveho majitele
        $("#btNew").button().click ->
            $trSelected = null
            clearEditDialog()
            $dlgEdit.dialog "option", "title", $(@).text()
            $dlgEdit.dialog "open"
            return false

        # kliknuti na radek v tabulce s koly
        $("#tblData").find("tbody").on "click", "td", (evn) ->
            $target = $(evn.target)
            $trSelected = $target.closest("tr")
            loadEdit $trSelected.data("id")
            return	

        if isAdmin
            deleteFullAll = ->
                App.progressShow()
                $.ajax
                    type: "post"
                    url: $("#hdDelFullOwnersUrl").val()
                    error: App.showAjaxFail
                    success: (data) ->
                        App.progressHide()
                        if data.error
                            App.alert data.msg
                        else
                            App.alert data.msg
                            table.fnReloadAjax() if data.count > 0
                            $dlgDelFull.dialog "close"
                        return
                return

            $dlgDelFull = $("#dlgDelFull").dialog
                autoOpen: false
                modal: true
                resizable: false
                width: $("#dlgDelFull").width()
                buttons: [
                    {
                        text: txt.btn_ok
                        click: ->				
                            deleteFullAll()			
                            return
                    }
                    {
                        text: txt.btn_cancel
                        click: -> $(@).dialog "close"
                    }
                ]

            # odstrani vsechny zaznamy, ktere jsou oznaceny jako zrusene
            $("#btDeleteFull").button().click ->
                $dlgDelFull.dialog "open"
                return false	
$ ->
    new OwnersClass
    return